import vtk
import math

depthsort=False
depthpeel=True

points = vtk.vtkPoints()
quads = vtk.vtkCellArray()
quad=vtk.vtkQuad()
actor=vtk.vtkActor() 
camera = vtk.vtkCamera()
renderer = vtk.vtkRenderer()
renderWindow = vtk.vtkRenderWindow()
renderWindow.AddRenderer(renderer)
renderWindowInteractor = vtk.vtkRenderWindowInteractor()
renderWindowInteractor.SetInteractorStyle(vtk.vtkInteractorStyleTrackballCamera()) #LAH-see clipping.txt
renderWindowInteractor.SetRenderWindow(renderWindow)
mbn=0
pname=""
pcolor="16"
pclass=0
ptype=0
pspgr=1.0
cname=""
copacity=1.0
cR=-1
cB=-1
cG=-1
nco=0
comb=[]
cop=[]
coc=[]
coR=[]
coG=[]
coB=[]
nlo=0
lomb=[]
lop=[]
lol=[]

xmax=0.0; xmin=0.0; ymax=0.0; ymin=0.0
heel=0; trim=0; az=0; dx=0; dy=0; dz=0
cheel=1; sheel=0; ctrim=1; strim=0; caz=1; saz=0

def color():
    i=0
    while (i < nco) and ((comb[i] != mbn) or (cop[i] != pname) or (coc[i] != cname)) : 
        i=i+1
    if i < nco :
        actor.GetProperty().SetColor(coR[i],coG[i],coB[i]) 

def color0():
    global pcolor
    if pcolor == "16" :
        if pclass != 0 :
            if pspgr >1.0 : pcolor="2"
            if pspgr == 1.0 : pcolor="1"
            if pspgr < 1.0 : pcolor="4"

def color1():
    if pcolor != "" :
        r=0. ; g=0. ; b=0.
        if pcolor == "1" : b=0.78
        if pcolor == "2" : g=0.78
        if pcolor == "3" : g=0.78; b=0.78
        if pcolor == "4" : r=0.78
        if pcolor == "5" : r=0.78; b=0.78
        if pcolor == "6" : r=0.78; g=0.5
        if pcolor == "7" : r=0.92; g=0.92; b=0.92
        if pcolor == "8" : r=.5 ; b=.5 ; g=.5
        if pcolor == "9" : g=0.23; b=2.
        if pcolor == "10" : g=2.
        if pcolor == "11" : g=2.; b=2.
        if pcolor == "12" : r=2.
        if pcolor == "13" : r=2.; b=2.
        if pcolor == "14" : r=2.; g=2.
        if pcolor == "15" : r=2.; g=2.; b=2.
        if pcolor == "16" : r=1.78; g=0.63
        if pcolor == "17" : r=0.94; g=0.63; b=2.
        if pcolor == "18" : r=1.; g=0.5; b=0.5
        if pcolor == "19" : r=1.; g=1.
        actor.GetProperty().SetColor(r,g,b)

def opacity1():
    opacity=1.0
    if pclass == 0 : opacity=0.5
    actor.GetProperty().SetOpacity(opacity)

def opacity2():
    if copacity > 0 : actor.GetProperty().SetOpacity(copacity)

def GQColor(partname,compname,R,G,B):
    if (R >=0) and (G >=0) and (B >=0) :
        global comb; global cop; global coc;  global coR; global coG; global coB; global nco
        global mbn
        nco=nco+1
        comb.append(1); cop.append(1); coc.append(1); coR.append(1); coG.append(1); coB.append(1)
        n=nco-1
        comb[n]=mbn
        cop[n]=partname
        coc[n]=compname
        coR[n]=R
        coG[n]=G
        coB[n]=B

def GQLoad(partname,LoadFraction):
        global comb; global lop; global lol; global nlo
        global mbn
        nlo=nlo+1
        lomb.append(1); lop.append(1); lol.append(1)
        n=nlo-1
        lomb[n]=mbn
        lop[n]=partname
        lol[n]=LoadFraction

def GQPart(partname,partclass,partcolor,partspgr,level):
    global pname
    global pcolor
    global pclass
    global pspgr
    pname=partname
    pclass=partclass
    pcolor=partcolor
    pspgr=partspgr
 
def GQComp(compname,effect,opacity,R,G,B):
    global points
    global quads
    global actor
    global cname
    global copacity
    if compname == "" :
        mapper=vtk.vtkPolyDataMapper()

        polydata = vtk.vtkPolyData()
        polydata.SetPoints(points)
        polydata.SetPolys(quads)

        if depthsort == False :
            mapper.SetInputData(polydata)
        else :
            #Taken from http://web.mit.edu/16.225/dv/VTK/Examples/VisualizationAlgorithms/Python/DepthSort.py
            #If the sorting works, it does not inprove the rendering with opacity<1
            #Also it seems to make setting the actor color ineffective
            appendData = vtk.vtkAppendPolyData()
            appendData.AddInputData(polydata)
            global camera
            camera = vtk.vtkCamera()
            depthSort = vtk.vtkDepthSortPolyData()
            depthSort.SetInputConnection(appendData.GetOutputPort())
            depthSort.SetDirectionToBackToFront()
            depthSort.SetVector(1, 1, 1)
            depthSort.SetCamera(camera)
            depthSort.SortScalarsOn()
            depthSort.Update()
            mapper.SetInputConnection(depthSort.GetOutputPort())
            #Do not know purpose of SetScalarRange
            #Seems to make multi colors
            #mapper.SetScalarRange(0, depthSort.GetOutput().GetNumberOfCells())

        skipact = False
        i=0
        while (i < nlo) and ((lomb[i] != mbn) or (lop[i] != pname)) : 
            i=i+1
        if i < nlo :
            if lol[i] == 0 : skipact = True

        if skipact == False :
            actor=vtk.vtkActor() 
            actor.SetMapper(mapper)
            color0()
            color1()
            color()
            opacity1()
            opacity2()
            renderer.AddActor(actor)
    else :
        points = vtk.vtkPoints()
        quads = vtk.vtkCellArray()
        cname=compname
        copacity=opacity
        GQColor(pname,cname,R,G,B)

def GQMB(n,h,t,a,x,y,z):
    global mbn ; mbn=n
    global heel ; heel=-h*0.0175
    global cheel ; cheel=math.cos(heel)
    global sheel ; sheel=math.sin(heel)
    global trim ; trim=t*0.0175
    global ctrim ; ctrim=math.cos(trim)
    global strim ; strim=math.sin(trim)
    global az ; az=a*0.0175
    global caz ; caz=math.cos(az)
    global saz ; saz=math.sin(az)
    global dx ; dx=x
    global dy ; dy=y
    global dz ; dz=z

def GQPt0(ipt, npt, x,y,z):
    global quad
    if ipt == 0 : 
        quad=vtk.vtkQuad()
    points.InsertNextPoint([x,z,y])
    quad.GetPointIds().SetId(ipt,npt)
    if ipt == 3 : quads.InsertNextCell(quad)

def GQPt(ipt, npt, x,y,z):
    y=-y
    y1=y*cheel
    y2=y*sheel
    z1=z*cheel
    z2=z*sheel    
    y=y1+z2
    z=z1-y2
    x1=x*ctrim
    x2=x*strim
    z1=z*ctrim
    z2=z*strim    
    x=x1+z2
    z=z1-x2
    x1=x*caz
    x2=x*saz
    y1=y*caz
    y2=y*saz    
    x=x1+y2
    y=y1-x2
    x=x+dx
    y=y-dy
    z=z-dz
    global quad
    if ipt == 0 : 
        quad=vtk.vtkQuad()
    points.InsertNextPoint([x,z,y])
    quad.GetPointIds().SetId(ipt,npt)
    if ipt == 3 : quads.InsertNextCell(quad)
    global xmax; global xmin; global ymax; global ymin
    if x>xmax : xmax=x
    if x<xmin : xmin=x
    if y>ymax : ymax=y
    if y<ymin : ymin=y

def GQWpl(h,t,depth):
    GQPart("Waterplane", 0, "1", 1., 0.);
    GQComp("WPL", 1., 0.2, -1,-1,-1);
    q=1.3
    GQPt0(0,0,xmin,ymin*q,depth)
    GQPt0(1,1,xmin,ymax*q,depth)
    GQPt0(2,2,xmax,ymax*q,depth)
    GQPt0(3,3,xmax,ymin*q,depth)
    GQComp("",0.,0.,0,0,0)
    actor.GetProperty().EdgeVisibilityOn()
    actor.GetProperty().SetEdgeColor(.25, .25, .25)

def capture(renwin, file,mag):
    w2i = vtk.vtkWindowToImageFilter()
    writer = vtk.vtkJPEGWriter()
    writer.SetQuality(85)
    #writer = vtk.vtkBMPWriter()
    w2i.SetInput(renwin)
    w2i.SetMagnification(mag)
    #w2i.SetInputBufferTypeToRGBA()
    #w2i.ReadFrontBufferOff()
    w2i.Update()
    writer.SetInputConnection(w2i.GetOutputPort())
    writer.SetFileName(file)
    renwin.Render()
    writer.Write ()

def winsize(renwin, x,y):
    renwin.SetSize(x,y)

def GQFinal(winx,winy,capturefile,mag,azimuth,elevation,zoom):
    #Following is attempt to use Depth Peeling: No effect or crashes VTK
    if depthpeel == True:
        renderWindow.SetAlphaBitPlanes(1)
        renderWindow.SetMultiSamples(0)
        renderer.SetUseDepthPeeling(1)
        renderer.SetMaximumNumberOfPeels(100)
        renderer.SetOcclusionRatio(0.1)

    camera=vtk.vtkCamera()
    camera.Elevation(elevation)
    camera.Azimuth(azimuth)
    renderer.SetActiveCamera(camera) 
    renderer.ResetCamera()
    camera.ParallelProjectionOn()
    scale=(xmax-xmin)*abs(math.cos(azimuth))+(ymax-ymin)*abs(math.sin(azimuth))
    camera.SetParallelScale(scale/1.5)
    camera.Zoom(zoom)
    
    renderer.SetBackground(1,1,1)

    renderWindow.Initialize()
    winsize(renderWindow,winx,winy)

    renderWindowInteractor.Initialize()
    renderWindow.Render()
    if capturefile != "" : 
        capture(renderWindow,capturefile,mag)
    else :
        renderWindowInteractor.Start()
  


